#!/usr/bin/python
# -*- coding: UTF-8 -*-

import base64
import optparse
import simplejson
import urllib2


def do_request(opts, relpathname, **kwargs):
    request = urllib2.Request('%s/%s' % (opts.jira_api_url, relpathname))
    if opts.jira_username and opts.jira_password:
        base64string = base64.encodestring(
            '%s:%s' % (opts.jira_username, opts.jira_password)
            ).replace('\n', '')
        request.add_header('Authorization', 'Basic %s' % base64string)
    request_data = None
    if kwargs.keys():
        request.add_header('Content-Type', 'application/json')
        request_data = simplejson.dumps(kwargs)
    response_data = urllib2.urlopen(request, request_data)
    return simplejson.load(response_data)


def main():
    parser = optparse.OptionParser(usage="%prog")
    parser.add_option("--jira-api-url", dest="jira_api_url",
        default="http://cards.linaro.org/rest/api/2")
    parser.add_option("--jira-username", dest="jira_username",
        default="robot")
    parser.add_option("--jira-password", dest="jira_password",
        default="cuf4moh2")
    opts, args = parser.parse_args()

    # simple search
    print do_request(opts, 'search', maxResults=1, jql='project = CARD',
                     fields=['summary', 'status'])

    # information about a project
    #print do_request(opts, 'project/CARD')

    # on creating issues
    #print do_request(opts, 'issue/createmeta?projectIds=10000')

    # on statuses
    #print do_request(opts, 'status')

    # on fields
    #print do_request(opts, 'field')

    # on a security level
    #print do_request(opts, 'securitylevel/10000')

if __name__ == "__main__":
    main()
